<template>
  <span>
    <mgl-geojson-layer
      layer-id="positionsSymbol"
      :layer="positionsSymbolLayer"
      type="geojson"
      source-id="positions"
      :source="positionsGeoJson"
    />
    <!--      WIP -->

  </span>
</template>

<script>
  import { mutations } from '../../store/constants'
  import { mapMutations, mapState } from 'vuex'
  import GeoJSON from 'geojson'
  import { MglGeojsonLayer } from 'vue-mapbox'
  import config from '../../../config'
  import mapWorker from '../../workers/positions'

  export default {
    name: 'MetrocheckLayerSymbolsPositions',

    components: {
      MglGeojsonLayer,
    },

    props: {
      displayedLines: { type: Array, required: true },
    },

    data: () => ({
      positionsSymbolLayer: config.map.layers.positionsSymbolLayer,
      displayedPositions: [],
    }),

    computed: {
      ...mapState(['displayedDatetime', 'hydrated', 'fetchedRange', 'positions']),

      positionsGeoJson: function () {
        const data = GeoJSON.parse(this.displayedPositions, {
          Point: ['point_geolocation.x', 'point_geolocation.y'],
          include: ['direction_fk', 'line_fk', 'id', 'distance_from_point', 'point_fk'],
        })

        return { type: 'geojson', data }
      },
    },

    watch: {
      displayedDatetime: async function (a, b) {
        // console.log('displayedDatetime changed from %O to %O', b, a)
        await this.refresh()
      },
      displayedLines: async function (a, b) {
        console.log('displayedLines changed from %O to %O', b, a)
        await this.refresh()
      },
      hydrated: async function (a, b) {
        console.log('hydrated', b, a)
        // await this.refresh()
      },
      positions: async function (a, b) {
        console.log('positions changed', b, a)
        // return this.updateDisplayedPositions()
      },
    },

    async created () {
      mapWorker.worker.addEventListener('message', this.handleWorkerMessage)
      mapWorker.worker.onerror = e => {
        console.error('mapWorker error : %O', e)
      }
      if (this.hydrated) {
        // console.log('LayerPosition created. Hydrated :%O', this.hydrated)
        await this.refresh()
      }
    },

    methods: {

      ...mapMutations({
        flash: 'FLASH/SET_FLASH',
        clearFlash: 'FLASH/CLEAR_FLASH',
        positionsLoading: mutations.SET_POSITIONS_LOADING,
      }),

      handleWorkerMessage (event) {
        // console.debug('layerPositions handleWorkerMessage : %O', event.data)
        switch (event.data.type) {
          case 'DISPLAY_MESSAGE':
            this.flash({ message: event.data.message, variant: event.data.variant || 'info' })
            break
          case 'DISPLAY_POSITIONS':
            this.clearFlash('info')
            this.displayedPositions = event.data.positions
            break
          case 'PERSIST_POSITIONS':
            this.$store.commit(mutations.SET_POSITIONS, event.data.positions)
            break
          case 'PERSIST_FETCHED_RANGE':
            this.$store.commit(mutations.ADD_FETCHED_TIME_RANGE, { from: event.data.from, to: event.data.to })
            break
          default:
            console.warn('Worker message type unknown')
        }
      },

      refresh: function () {
        mapWorker.send({
          action: 'POSITIONS_AT',
          args: {
            from: this.displayedDatetime,
            to: null,
            lines: this.displayedLines,
            fetched: this.fetchedRange,
          },
        })
      },
    },
  }
</script>
